<?php

namespace Drupal\vlsuite_collection_cta\Entity\Bundle;

use Drupal\Core\Entity\EntityTypeInterface;
use Drupal\vlsuite_block\Entity\Bundle\VLSuiteBlockBase;
use Drupal\vlsuite_bundle_field\BundleField\VLSuiteBundleFieldCtaTrait;
use Drupal\vlsuite_bundle_field\BundleField\VLSuiteBundleFieldTextTrait;
use Drupal\vlsuite_bundle_field\BundleField\VLSuiteBundleFieldImageTrait;

/**
 * Bundle class for VLSuiteCollectionCta.
 */
class VLSuiteCollectionCta extends VLSuiteBlockBase {

  const BUNDLE_KEY = 'vlsuite_collection_cta';

  use VLSuiteBundleFieldCtaTrait {
    VLSuiteBundleFieldCtaTrait::bundleFieldDefinitions as bundleFieldDefinitionsCta;
  }

  use VLSuiteBundleFieldTextTrait {
    VLSuiteBundleFieldTextTrait::bundleFieldDefinitions as bundleFieldDefinitionsText;
  }

  use VLSuiteBundleFieldImageTrait {
    VLSuiteBundleFieldImageTrait::bundleFieldDefinitions as bundleFieldDefinitionsImage;
  }

  /**
   * {@inheritdoc}
   */
  public static function bundleFieldDefinitions(EntityTypeInterface $entity_type, $bundle, array $base_field_definitions): array {
    $fields = parent::bundleFieldDefinitions($entity_type, $bundle, $base_field_definitions);

    $fields += self::bundleFieldDefinitionsCta($entity_type, $bundle, $base_field_definitions);
    $fields += self::bundleFieldDefinitionsText($entity_type, $bundle, $base_field_definitions);
    $fields += self::bundleFieldDefinitionsImage($entity_type, $bundle, $base_field_definitions);

    return $fields;
  }

}
